<?php
/************************************************************************\
 *
 * AMPXF
 *
 * Copyright ©2020 JEAW Ab. All Rights Reserved.
 * This file may not be redistributed in whole or significant part.
 *
 * AMPXF IS NOT FREE SOFTWARE
 * https://ampxf.com/
 *
 * \************************************************************************/

namespace MaZ\AMP\Compat\EWR\Porta\Pub\Controller;

use MaZ\AMP\Compat\AMPCompat;
use XF\Mvc\ParameterBag;
use XF\Mvc\Reply\View;

class Article extends XFCP_Article
{
    public function actionIndex(ParameterBag $params)
    {
        if ($this->request->filter('amp-pixel', 'str') == '1') {
            return $this->rerouteController(__CLASS__, 'pixel', $params);
        }
        $reply = parent::actionIndex($params);
        if ($reply instanceof View) {
            $templater = $this->app->templater();
            $page = max(1, $params->page);
            $article_url = $this->buildLink('full:ewr-porta', '', ['page' => $page]);
            if ($this->request->filter('amp', 'str') == '1') {
                AMPCompat::set_amp_page_params($reply, $templater, $article_url);
            } else {
                AMPCompat::set_meta_amp_url($templater, $article_url);
            }
        }
        return $reply;
    }

    public function actionPixel(ParameterBag $params)
    {
        $cache = $this->app->simpleCache()->getSet('MaZ/AMP');
        $cache->setValue('pixel', $cache->getValue('pixel') + 1);
        return $this->view('MaZ\AMP\Pub\View\AMPPixelView', '');
    }
}