<?php
/************************************************************************\
 *
 * AMPXF
 *
 * Copyright ©2020 JEAW Ab. All Rights Reserved.
 * This file may not be redistributed in whole or significant part.
 *
 * AMPXF IS NOT FREE SOFTWARE
 * https://ampxf.com/
 *
 * \************************************************************************/

namespace MaZ\AMP\Compat\XenAddons\AMS\Pub\Controller;

use MaZ\AMP\Compat\AMPCompat;
use XF\Mvc\ParameterBag;
use XF\Mvc\Reply\View;

class ArticleItem extends XFCP_ArticleItem
{
    public function actionIndex(ParameterBag $params)
    {
        if ($params->article_id && $this->request->filter('amp-pixel', 'str') == '1') {
            return $this->rerouteController(__CLASS__, 'pixel', $params);
        }
        return parent::actionIndex($params);
    }

    public function actionView(ParameterBag $params)
    {
        $reply = parent::actionView($params);
        if ($reply instanceof View) {
            $templater = $this->app->templater();
            $article = $reply->getParam('article');
            $article_url = $this->buildLink('full:ams', $article, ['page' => $params->page]);
            if ($this->request->filter('amp', 'str') == '1') {
                AMPCompat::set_amp_page_params($reply, $templater, $article_url);
            } else {
                AMPCompat::set_meta_amp_url($templater, $article_url);
            }
        }
        return $reply;
    }

    public function actionPixel(ParameterBag $params)
    {
        $this->assertViewableArticle($params->article_id, $this->getArticleViewExtraWith());
        $cache = $this->app->simpleCache()->getSet('MaZ/AMP');
        $cache->setValue('pixel', $cache->getValue('pixel') + 1);
        return $this->view('MaZ\AMP\Pub\View\AMPPixelView', '');
    }
}