<?php
/************************************************************************\
 *
 * AMPXF
 *
 * Copyright ©2020 JEAW Ab. All Rights Reserved.
 * This file may not be redistributed in whole or significant part.
 *
 * AMPXF IS NOT FREE SOFTWARE
 * https://ampxf.com/
 *
 * \************************************************************************/

namespace MaZ\AMP\Compat\XenAddons\CAS\Pub\Controller;

use MaZ\AMP\Compat\AMPCompat;
use XF\Mvc\ParameterBag;
use XF\Mvc\Reply\View;

class Ad extends XFCP_Ad
{
    public function actionIndex(ParameterBag $params)
    {
        if ($params->ad_id && $this->request->filter('amp-pixel', 'str') == '1') {
            return $this->rerouteController(__CLASS__, 'pixel', $params);
        }
        return parent::actionIndex($params);
    }

    public function actionView(ParameterBag $params)
    {
        $reply = parent::actionView($params);
        if ($reply instanceof View) {
            $templater = $this->app->templater();
            $ad = $reply->getParam('ad');
            $ad_url = $this->buildLink('full:cas', $ad);
            if ($this->request->filter('amp', 'str') == '1') {
                AMPCompat::set_amp_page_params($reply, $templater, $ad_url);
            } else {
                AMPCompat::set_meta_amp_url($templater, $ad_url);
            }
        }
        return $reply;
    }

    public function actionQuestions(ParameterBag $params)
    {
        $reply = parent::actionQuestions($params);
        if ($reply instanceof View) {
            $templater = $this->app->templater();
            $ad = $reply->getParam('ad');
            $ad_url = $this->buildLink('full:cas/questions', $ad);
            if ($this->request->filter('amp', 'str') == '1') {
                AMPCompat::set_amp_page_params($reply, $templater, $ad_url);
            } else {
                AMPCompat::set_meta_amp_url($templater, $ad_url);
            }
        }
        return $reply;
    }

    public function actionPixel(ParameterBag $params)
    {
        $this->assertViewableAd($params->ad_id, $this->getAdViewExtraWith());
        $cache = $this->app->simpleCache()->getSet('MaZ/AMP');
        $cache->setValue('pixel', $cache->getValue('pixel') + 1);
        return $this->view('MaZ\AMP\Pub\View\AMPPixelView', '');
    }
}