<?php
/************************************************************************\
 *
 * AMPXF
 *
 * Copyright ©2020 JEAW Ab. All Rights Reserved.
 * This file may not be redistributed in whole or significant part.
 *
 * AMPXF IS NOT FREE SOFTWARE
 * https://ampxf.com/
 *
 * \************************************************************************/

namespace MaZ\AMP\Compat\XenAddons\UBS\Pub\Controller;

use MaZ\AMP\Compat\AMPCompat;
use XF\Mvc\ParameterBag;
use XF\Mvc\Reply\View;

class BlogEntryPage extends XFCP_BlogEntryPage
{
    public function actionIndex(ParameterBag $params)
    {
        if ($params->page_id && $this->request->filter('amp-pixel', 'str') == '1') {
            return $this->rerouteController(__CLASS__, 'pixel', $params);
        }
        return parent::actionIndex($params);
    }

    public function actionView(ParameterBag $params)
    {
        $reply = parent::actionView($params);
        if ($reply instanceof View) {
            $templater = $this->app->templater();
            $blog_entry_page = $reply->getParam('blogEntryPage');
            $blog_entry_page_url = $this->buildPaginatedLink('full:ubs/page', $blog_entry_page, $this->filterPage($params->page));
            if ($this->request->filter('amp', 'str') == '1') {
                AMPCompat::set_amp_page_params($reply, $templater, $blog_entry_page_url);
            } else {
                AMPCompat::set_meta_amp_url($templater, $blog_entry_page_url);
            }
        }
        return $reply;
    }

    public function actionPixel(ParameterBag $params)
    {
        $this->assertViewableBlogEntry($params->blog_entry_id, $this->getBlogEntryViewExtraWith());
        $cache = $this->app->simpleCache()->getSet('MaZ/AMP');
        $cache->setValue('pixel', $cache->getValue('pixel') + 1);
        return $this->view('MaZ\AMP\Pub\View\AMPPixelView', '');
    }
}