<?php
/************************************************************************\
 *
 * AMPXF
 *
 * Copyright ©2020 JEAW Ab. All Rights Reserved.
 * This file may not be redistributed in whole or significant part.
 *
 * AMPXF IS NOT FREE SOFTWARE
 * https://ampxf.com/
 *
 * \************************************************************************/

namespace MaZ\AMP;

use GuzzleHttp\Exception\RequestException;
use MaZ\AMP\Compat\AMPCompat;
use XF;
use XF\AddOn\AbstractSetup;

class Setup extends AbstractSetup
{
    public function install(array $stepParams = [])
    {
    }

    public function upgrade(array $stepParams = [])
    {
    }

    public function uninstall(array $stepParams = [])
    {
    }

    protected function enableRobot()
    {

    }

    public function postInstall(array &$stateChanges)
    {
        self::enableRobot();
        AMPCompat::set_active_ad_positions();
        AMPCompat::set_active_template_modifications();
        try { // Submit sitemap for faster AMP indexing (Google & Bing) after first install
            XF::app()->http()->client()->get('https://ampsiteindexer.com/submit', ['query' => [
                'sitemap' => $this->app()->router('public')->buildLink('full:sitemap.xml'),]]);
        } catch (RequestException $e) {
        }
    }

    public function postRebuild()
    {
        XF::app()->simpleCache()->deleteSet('MaZ/AMP');
        AMPCompat::set_active_ad_positions();
        AMPCompat::set_active_template_modifications();
    }

    public function postUpgrade($previousVersion, array &$stateChanges)
    {
        XF::app()->simpleCache()->deleteSet('MaZ/AMP');
        self::enableRobot();
        AMPCompat::set_active_ad_positions();
        AMPCompat::set_active_template_modifications();
    }
}