<?php
/************************************************************************\
 *
 * AMPXF
 *
 * Copyright ©2020 JEAW Ab. All Rights Reserved.
 * This file may not be redistributed in whole or significant part.
 *
 * AMPXF IS NOT FREE SOFTWARE
 * https://ampxf.com/
 *
 * \************************************************************************/

namespace MaZ\AMP\XF\BbCode\Renderer;

use DOMDocument;

class Html extends XFCP_Html
{

    protected function getRenderedQuote($content, $name, array $source, array $attributes)
    {
        if (!empty($this->templater->pageParams['isAMP'])) {
            $disable_errors = libxml_use_internal_errors(true);
            $dom = new DOMDocument();
            if ($dom->loadHTML($content)) {
                $text_content = $dom->textContent;
            } else {
                $text_content = $content;
            }
            libxml_use_internal_errors($disable_errors);

            $expand_class = 'is-expanded';
            if (strlen($text_content) > 250) {
                $expand_class = 'is-expandable';
            }
            return $this->templater->renderTemplate('public:amp_bb_code_tag_quote', [
                'content' => new \XF\PreEscaped($content),
                'expandClass' => $expand_class,
                'name' => $name ? new \XF\PreEscaped($name) : null,
                'source' => $source,
                'attributes' => $attributes
            ]);
        }
        return parent::getRenderedQuote($content, $name, $source, $attributes);
    }
}