<?php
/************************************************************************\
 *
 * AMPXF
 *
 * Copyright ©2020 JEAW Ab. All Rights Reserved.
 * This file may not be redistributed in whole or significant part.
 *
 * AMPXF IS NOT FREE SOFTWARE
 * https://ampxf.com/
 *
 * \************************************************************************/

namespace MaZ\AMP\XF\Pub\Controller;

use MaZ\AMP\Compat\AMPCompat;
use XF\Mvc\Reply\View;
use XF\Mvc\ParameterBag;

class Tag extends XFCP_Tag
{
    public function actionTag(ParameterBag $params)
    {
        if ($params->tag_url && $this->request->filter('amp-pixel', 'str') == '1') {
            return $this->rerouteController(__CLASS__, 'pixel', $params);
        }
        $reply = parent::actionTag($params);
        if ($reply instanceof View) {
            $templater = $this->app->templater();
            $tag = $reply->getParam('tag');

            $page = $this->filterPage($params->page);
            $tag_url = $this->buildLink('full:tags', $tag, ['page' => $page]);
            if ($this->request->filter('amp', 'str') == '1') {
                AMPCompat::set_amp_page_params($reply, $templater, $tag_url);
            } else {
                AMPCompat::set_meta_amp_url($templater, $tag_url);
            }
        }
        return $reply;
    }

    public function actionPixel(ParameterBag $params)
    {
        $cache = $this->app->simpleCache()->getSet('MaZ/AMP');
        $cache->setValue('pixel', $cache->getValue('pixel') + 1);
        return $this->view('MaZ\AMP\Pub\View\AMPPixelView', '');
    }
}
