<?php
/************************************************************************\
 *
 * AMPXF
 *
 * Copyright ©2020 JEAW Ab. All Rights Reserved.
 * This file may not be redistributed in whole or significant part.
 *
 * AMPXF IS NOT FREE SOFTWARE
 * https://ampxf.com/
 *
 * \************************************************************************/

namespace MaZ\AMP\XF\Template\XF22;

use XF\Template\ExtensionSet;

class Templater extends XFCP_Templater
{
    public function renderTemplate($template, array $params = [], $addDefaultParams = true, ExtensionSet $extensionOverrides = null)
    {
        if ($this->app->request()->filter('amp', 'str') == '1') {
            if ($template == 'public:PAGE_CONTAINER') {
                $template = 'public:AMP_CONTAINER';
            }
            if ($template == 'public:uw_post_comments_main') {
                $html = parent::renderTemplate($template, $params, $addDefaultParams, $extensionOverrides);
                return preg_replace('#/load-previous-comments\?before=\d+#s', '', $html);
            }
            if (strpos($template, 'public:amp_') === 0 && !parent::isKnownTemplate($template)) {
                // special type Thread views are amp_-prepended in Controller, remove it here to use default template
                $template = str_replace(':amp_', ':', $template);
            }
            if (in_array($template, array('public:bb_code_tag_attach', 'public:bb_code_tag_img', 'public:bb_code_tag_url_unfurl'))) {
                $template = substr_replace($template, 'amp_', 7, 0);
            }
            if (strpos($template, 'public:_media_site_embed') === 0) {
                $amp_template = str_replace('public:_media_site_embed', 'public:_amp_media_site_embed', $template);
                if (parent::isKnownTemplate($amp_template)) {
                    return parent::renderTemplate($amp_template, $params, $addDefaultParams, $extensionOverrides);
                }
                $html = parent::renderTemplate($template, $params, $addDefaultParams, $extensionOverrides);
                return '<!--- AMPRobot debug: Embed template "' . $amp_template . '" is missing, using non-amp variant. --->' . $html;
            }
            if ($template == 'public:setup.less') {
                $template = 'public:ampsetup.less';
            }
            if ($template == 'public:widget_EWRporta_features') {
                $template = 'public:amp_widget_EWRporta_features';
            }
        }
        return parent::renderTemplate($template, $params, $addDefaultParams, $extensionOverrides);
    }
}
